Graphics3D 800,600,32,2
SetBuffer BackBuffer()

SetFont LoadFont(Arial,12)

;  
pxCreateWorld(1,"")
pxSetGravity(0,-10,0)


; +++++++  +++++++

; ----  ----
mat_stat1=pxCreateMaterial()
pxMaterialSetStFriction(mat_stat1,0.1)		;   [0,inf]
pxMaterialSetRestitution(mat_stat1,0.5)		;  [0,1]


; ----  ----
mat_dyn1=pxCreateMaterial()
pxMaterialSetDyFriction(mat_dyn1,0.1)		;   [0,inf] 
pxMaterialSetRestitution(mat_dyn1,0.1)		;  [0,1]

mat_dyn2=pxCreateMaterial()
pxMaterialSetDyFriction(mat_dyn2,50)		;   [0,inf] 
pxMaterialSetRestitution(mat_dyn2,0.2)		;  [0,1]

mat_dyn3=pxCreateMaterial()
pxMaterialSetDyFriction(mat_dyn3,0.1)		;   [0,inf] 
pxMaterialSetRestitution(mat_dyn3,0.9)		;  [0,1]


mat_dyn4=pxCreateMaterial()
pxMaterialSetDyFriction(mat_dyn4,0.1)		;   [0,inf] 
pxMaterialSetRestitution(mat_dyn4,0.1)		;  [0,1]
pxMaterialSetFrictionCombineMode(mat_dyn4,1)		;  
pxMaterialSetRestitutionCombineMode(mat_dyn4,1)		;  

mat_dyn5=pxCreateMaterial()
pxMaterialSetDyFriction(mat_dyn5,50)		;   [0,inf] 
pxMaterialSetRestitution(mat_dyn5,0.2)		;  [0,1]
pxMaterialSetFrictionCombineMode(mat_dyn5,2)		;  
pxMaterialSetRestitutionCombineMode(mat_dyn5,2)		;  

mat_dyn6=pxCreateMaterial()
pxMaterialSetDyFriction(mat_dyn6,0.1)		;   [0,inf] 
pxMaterialSetRestitution(mat_dyn6,0.9)		;  [0,1]
pxMaterialSetFrictionCombineMode(mat_dyn6,3)		;  
pxMaterialSetRestitutionCombineMode(mat_dyn6,3)		;  

; ++++++++++++++++++++++++++++++++++++++++++++++


; 
cam=CreateCamera()
PositionEntity cam,15,7,-15
RotateEntity cam,20,35,0

; 
light=CreateLight()
PositionEntity light,10,10,-10

; 
plane=CreatePlane()
EntityAlpha plane,0.5
CreateMirror()

;   ( ))))
gorka_body=pxBodyCreateCube(10,.2,10,0)
pxBodySetRotation gorka_body,0,0,-25
pxBodySetPosition gorka_body,0,5,0
gorka=CreateCube()
ScaleEntity gorka,10,.2,10
pxBodySetEntity gorka,gorka_body
pxMaterialSetToBody(gorka_body,mat_stat1)


; ===========   ===========
While Not KeyDown(1)
	
	If KeyHit(57) Then state=1-state
		
	If KeyHit(28) Then	
		DeletepxCubes()	
		Select state
			Case 0 
			CreatepxCube(-3,10,-3,mat_dyn1)
			CreatepxCube(-3,10,0,mat_dyn2)
			CreatepxCube(-3,10,3,mat_dyn3)			
			
			Case 1
			CreatepxCube(-3,10,-3,mat_dyn4)
			CreatepxCube(-3,10,0,mat_dyn5)
			CreatepxCube(-3,10,3,mat_dyn6)
		End Select         	
	End If
	
	pxRenderPhysic(60,0)
	UpdatepxCubes()
	RenderWorld
	
	If state=0 Then
		Text 10,10,"Normal mode"
		Else
		Text 10,10,"Combine mode"
	EndIf
	
	Flip
Wend
End

Type pxCube
	Field mesh
	Field body
	Field material
End Type

Function CreatepxCube(x#,y#,z#,mat%=0)
	pxC.pxCube = New pxCube
	pxC\mesh = CreateCube()
	pxC\body = pxBodyCreateCube(1,1,1,1)
	pxC\material = mat
	If mat<>0 Then pxMaterialSetToBody(pxC\body,pxC\material)	
	pxBodySetPosition pxC\body,x,y,z	
End Function

Function UpdatepxCubes()
	For pxC.pxCube = Each pxCube
		pxBodySetEntity pxC\mesh, pxC\body
	Next
End Function

Function DeletepxCubes()
	For pxC.pxCube = Each pxCube
	FreeEntity pxC\mesh 
	pxDeleteBody pxC\body 
	Delete pxC		
	Next
End Function